#ifndef __BP35A1_MESSAGE_H__
#define __BP35A1_MESSAGE_H__

#include <glib-object.h>
#include "bp35a1-raw-message.h"

G_BEGIN_DECLS

#define BP35A1_TYPE_MESSAGE            (bp35a1_message_get_type ())
#define BP35A1_MESSAGE(o)              (G_TYPE_CHECK_INSTANCE_CAST  ((o), BP35A1_TYPE_MESSAGE, Bp35a1Message))
#define BP35A1_IS_MESSAGE(o)           (G_TYPE_CHECK_INSTANCE_TYPE  ((o), BP35A1_TYPE_MESSAGE))
#define BP35A1_MESSAGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), BP35A1_TYPE_MESSAGE, Bp35a1MessageClass))
#define BP35A1_IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BP35A1_TYPE_MESSAGE))
#define BP35A1_MESSAGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BP35A1_TYPE_MESSAGE, Bp35a1MessageClass))

typedef enum {
  BP35A1_MESSAGE_UNKNOWN,
  BP35A1_MESSAGE_OK,
  BP35A1_MESSAGE_SKSREG,
  BP35A1_MESSAGE_SKINFO,
  BP35A1_MESSAGE_SKSENDTO,
  BP35A1_MESSAGE_ERXUDP,
  BP35A1_MESSAGE_ESREG,
  BP35A1_MESSAGE_EVENT
} Bp35a1MessageType;

typedef struct {
  const Bp35a1MessageType type;
  const gchar *name;
} Bp35a1MessageTypeHash;

typedef struct {
  GObject parent_instance;

  Bp35a1RawMessage *raw;
} Bp35a1Message;

typedef struct {
  GObjectClass parent_class;
} Bp35a1MessageClass;

GType          bp35a1_message_get_type (void) G_GNUC_CONST;
Bp35a1Message *bp35a1_message_new (void);
Bp35a1Message *bp35a1_message_overwrite (Bp35a1Message * message, GByteArray * data);
GByteArray    *bp35a1_message_read (Bp35a1Message * message);
Bp35a1MessageType bp35a1_message_get_message_type (Bp35a1Message * message);
const gchar *bp35a1_message_type_get_name (Bp35a1MessageType type);
gchar * bp35a1_message_get_mac_address (Bp35a1Message * message);
Bp35a1Message ** bp35a1_message_split (Bp35a1Message * message);

G_END_DECLS

#endif /* __BP35A1_MESSAGE_H__ */
