#include "common.h"
#include <glib.h>

ssize_t xwrite (int fd, const void *buf, size_t count)
{
  const char *remain = buf;
  ssize_t ret;
  int total = 0;
  while (count > 0)
  {
    ret = write (fd, remain, count);
    if (ret < 0 && errno != EINTR)
    {
      if(total != 0){
        return total;
      }
      return ret;
    }
    if (ret > 0)
    {
      remain += ret;
      count -= ret;
      total += (int)ret;
    }
  }
  return total;
}

ssize_t xread (int fd, void *buf, size_t count)
{
  ssize_t ret;
  int total = 0;
  while (count > 0)
  {
    ret = read (fd, buf, count);
    if (ret < 0 && errno != EINTR)
    {
      if(total != 0){
        return total;
      }
      return ret;
    }
    if (ret > 0)
    {
      buf += ret;
      count -= ret;
      total += (int)ret;
    }
  }
  return total;
}
