#ifndef __FLUENTD_CLIENT_H__
#define __FLUENTD_CLIENT_H__

#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <ctype.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define FLUENTD_TYPE_CLIENT            (fluentd_client_get_type ())
#define FLUENTD_CLIENT(o)              (G_TYPE_CHECK_INSTANCE_CAST  ((o), FLUENTD_TYPE_CLIENT, FluentdClient))
#define FLUENTD_IS_CLIENT(o)           (G_TYPE_CHECK_INSTANCE_TYPE  ((o), FLUENTD_TYPE_CLIENT))
#define FLUENTD_CLIENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), FLUENTD_TYPE_CLIENT, FluentdClientClass))
#define FLUENTD_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FLUENTD_TYPE_CLIENT))
#define FLUENTD_CLIENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), FLUENTD_TYPE_CLIENT, FluentdClientClass))

#define FLUENTD_CLIENT_SOCKNAME "/tmp/sensor.sock"

enum {
  FLUENTD_CLIENT_PROP_0,
  FLUENTD_CLIENT_PROP_SOCKNAME,
};

typedef struct _FluentdClient {
  GObject parent_instance;

  struct sockaddr_un addr;
  gint fd;
  gchar *sockname;
} FluentdClient;

typedef struct _FluentdClientClass {
  GObjectClass parent_class;
} FluentdClientClass;

GType          fluentd_client_get_type (void) G_GNUC_CONST;
FluentdClient *fluentd_client_new (gchar *sockname);
void           fluentd_client_post_json (FluentdClient * client, gchar * tag, gchar * json);

gchar * fluentd_client_get_sockname (FluentdClient * client);
void    fluentd_client_set_sockname (FluentdClient * client, const gchar * string);

G_END_DECLS

#endif /* __FLUENTD_CLIENT_H__ */
